<template>
  <div v-if="msgUser" class="d-flex flex-col layout" :class="{ show: viewProfile }">

    <!-- Close button -->
    <button class="close-button icon-button" @click="hideProfile">
      <v-icon>
        <v-icon name="times"/>
        <v-icon name="regular/circle" scale="2"/>
      </v-icon>
    </button>

    <div class="scrollable d-flex flex-col">
      <div>
        <div class="pictures"
        >
          <img v-for="(pic, index) of msgUser.media" :key="pic" :src="pic"
          class="match-image" :style="{
            'margin-left': `${(index * 100) - (picIndex * 100)}%`
          }">

          <!-- left and right buttons -->
          <button class="left" @click="picIndex = Math.max(0, picIndex - 1)">
            previous
          </button>
          <button class="right"
            @click="picIndex = Math.min(msgUser.media.length - 1, picIndex + 1)">
            next
          </button>
        </div>
      </div>

      <div class="flex-1 pt-1 bg-white text-left">
        <h2 class="text-left mb-1 ph-3">
        {{ msgUser.name.first }} <small class="text-thin">{{ msgUser.age }}</small>
        </h2>
        <div class="d-flex flex-col pb-2 ph-5 profile-header"
          style="border-bottom: 1px solid #e8e8e8">
          <span class="text-secondary d-flex flex-ai-center">
            <v-icon name="map-marker-alt" class="fa-fw"/>
            {{ `${msgUser.distance} Km away` }}
          </span>
          <span class="text-secondary d-flex flex-ai-center">
            <v-icon name="regular/user" class="fa-fw"/>
            {{
              msgUser.sex == 'male' ? 'Man' :
              msgUser.sex == 'female' ? 'Woman' : 'Other'
            }}
          </span>
          <span class="text-secondary d-flex flex-ai-center">
            <v-icon name="regular/star" class="fa-fw"/>
            {{ msgUser.fame_rating.toFixed(2) }}
          </span>
          <span class="text-secondary d-flex flex-ai-center">
            <v-icon name="regular/clock" class="fa-fw"/>
            {{ (new Date(msgUser.match.since)).toLocaleDateString() }}
          </span>
        </div>

        <p class="ph-5">{{ msgUser.bio }}</p>


        <p class="ph-5">
          Interested in
          <ul>
            <li v-for="i of msgUser.interests" :key="i._id">{{ i.name }}</li>
          </ul>
        </p>
        <div class="d-flex flex-row bottom-bar">
          <a class="mh-auto mv-3 pointer text-primary" @click="block">BLOCK USER</a>
        </div>
      </div>
    </div>

    <div class="d-flex flex-row bottom-bar">
      <AsyncButton :fn="unmatch">UNMATCH</AsyncButton>
      <AsyncButton :fn="report">REPORT</AsyncButton>
    </div>
  </div>
</template>

<script>
import { mapState } from 'vuex';
import Vue from 'vue';
import axios from 'axios';

export default {
  data: () => ({
    picIndex: 0,
  }),
  computed: {
    ...mapState(['msgUser', 'viewProfile']),
  },
  watch: {
    msgUser() {
      this.picIndex = 0;
    },
  },
  methods: {
    hideProfile() {
      Vue.set(this.$store.state, 'viewProfile', false);
    },
    async report() {
      let id = this.msgUser._id;
      let question = `Why are you reporting ${this.msgUser.name.first}?`;
      let message = window.prompt(question);
      try {
        let { data: user } = await axios.post(`/api/user/report/${id}`, {
          message
        });
        Vue.set(this.$store.state, 'msgUser', null);
        Vue.set(this.$store.state, 'user', user);
        Vue.delete(this.$store.state.matches, id);
      }
      catch(e) { e; }
    },
    async block() {
      let msg = `Are you sure you block ${this.msgUser.name.first}?`;
      if (window.confirm(msg)) {
        let id = this.msgUser._id;
        try {
          let { data: user } = await axios.post(`/api/user/block/${id}`);
          Vue.set(this.$store.state, 'user', user);
          Vue.set(this.$store.state, 'msgUser', null);
          Vue.delete(this.$store.state.matches, id);
        }
        catch(e) { e; }
      }
    },
    async unmatch() {
      let msg = `Are you sure you want to unmatch ${this.msgUser.name.first}?`;
      if (window.confirm(msg)) {
        let id = this.msgUser._id;
        try {
          let { data: user } = await axios.post(`/api/user/unmatch/${id}`);
          Vue.set(this.$store.state, 'user', user);
          Vue.set(this.$store.state, 'msgUser', null);
          Vue.delete(this.$store.state.matches, id);
        }
        catch(e) { e; }
      }
    },
  },
};
</script>

<style scoped>
.close-button {
  position: absolute;
  right: 1.25rem;
  top: 1.25rem;
  z-index: 9;
  color: white;
}

.layout {
  flex: 0 1 40%;
  height: 100%;
  max-width: 400px;

  position: relative;

  overflow: hidden;

  border-left: 1px solid #e8e8e8;
}

.layout:not(.show) { display: none; }

.scrollable {
  flex-grow: 1;
  height: 100%;
  overflow-y: auto;
  overflow-x: hidden;
  scrollbar-width: none; /* remove scrollbar from firefox */
}

.scrollable::-webkit-scrollbar {
  width: 0; /* remove scrollbar from chrome */
}

.pictures {
  position: relative;
  height: 667px;
  max-height: calc(100vh - 99px - 2em);
  min-height: 400px;
}

.match-image {
  width: 100%;
  height: 100%;
  object-fit: cover;
  position: absolute;
  top: 0;
  left: 0;

  transition: .5s all;
}

.left,
.right {
  position: absolute;
  height: 100%;
  width: 20%;
  top: 0;
  border-radius: 0;
  opacity: 0;
}

.left { left: 0; }
.right { right: 0; }

.bottom-bar {
  flex: 0 0 75px;
  width: 100%;
  border-top: 1px solid #e8e8e8;
}

.bottom-bar button {
  flex: 1;
  background: transparent;
  border-radius: 0;
}

.bottom-bar button:not(:last-child) {
  border-right: 1px solid #e8e8e8;
}

.bottom-bar button:hover {
  background: var(--color-pink);
  border-right-color: transparent;
  color: white;
}

.profile-header .fa-icon {
  width: 20px;
}

@media only screen and (max-width: 960px) {
  .layout {
    position: absolute;
    width: 100%;
    height: 100%;
    left: 0;
    top: 0;

    border: 0;

    max-width: unset;
  }
}
</style>
